Imports System.IO

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each drive_info As DriveInfo In DriveInfo.GetDrives()
            lstDrives.Items.Add(drive_info.Name)
        Next drive_info
    End Sub

    Private Sub lstDrives_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstDrives.SelectedIndexChanged
        Dim drive_info As New DriveInfo(lstDrives.Text)
        txtResults.Text = GetNtfsInfo(lstDrives.Text)
        txtResults.Select(0, 0)
    End Sub

    Private Function GetNtfsInfo(ByVal drive_name As String) As String
        Dim result As String = ""

        Try
            ' Set start information.
            If drive_name.EndsWith("\") Then drive_name = drive_name.Substring(0, drive_name.Length - 1)
            Dim start_info As New ProcessStartInfo("fsutil", " fsinfo ntfsinfo " & drive_name)
            start_info.UseShellExecute = False
            start_info.CreateNoWindow = True
            start_info.RedirectStandardOutput = True
            start_info.RedirectStandardError = True

            ' Make the process and set its start information.
            Dim proc As New Process()
            proc.StartInfo = start_info

            ' Start the process.
            proc.Start()

            ' Attach to stdout and stderr.
            Dim std_out As StreamReader = proc.StandardOutput()
            Dim std_err As StreamReader = proc.StandardError()

            ' Display the results.
            result = std_out.ReadToEnd() & std_err.ReadToEnd()

            ' Clean up.
            std_out.Close()
            std_err.Close()
            proc.Close()
        Catch ex As Exception
            result = "Error getting information" & vbCrLf & vbCrLf & ex.Message
        End Try

        Return result
    End Function

    ' Format a disk size in bytes as KB, MB, GB, etc.
    Private Function FormatBytes(ByVal num_bytes As Double, ByVal format_str As String) As String
        Dim postfixes() As String = {"Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"}
        For i As Integer = postfixes.Length - 1 To 0 Step -1
            If num_bytes > 1024 ^ i Then
                num_bytes /= 1024 ^ i
                Return num_bytes.ToString(format_str) & " " & postfixes(i)
            End If
        Next i

        Return num_bytes.ToString(format_str) & " Bytes"
    End Function
End Class
